<template>
	<!--弹窗-->
	<div class="yidialog-con" id="Dia">
		<div class="yid-con flex-row yid-con-col">
			<div class="yid-cls-con">
				<!-- 弹窗内容	-->
				<div class="hello" style="width: 3rem; height: 3rem; background: #ccc;"></div>
				<div class="world" style="width: 6rem; height: 6rem; background: red;"></div>
			</div>
		</div>
	</div>
</template>

<script>
	export default {
		data: {
			courseImg: resourcePath + '/imgs/groupPurchase/newCourseImg/',
			imgPath: resourcePath + '/imgs/groupPurchase/act/',
			pageName: $('body').data('page-name')
		},
		// pvuvkey
		pvuvKey: {},
		// 初始化
		init: function () {
			var _this = this;

			// test
			var $Dia = this.popupAlert.get$Dia('hello');
			console.log($Dia)
			_this.popupAlert.show('sfa');
			setTimeout(function () {
				_this.popupAlert.show('world');
				setTimeout(function () {
					_this.popupAlert.hide();
					setTimeout(function () {
						_this.popupAlert.show('hello')
					}, 2000)
				}, 1000)
			}, 2000)
		},
		/**
		 * 曝光统计
		 */
		scrollExposure: function ($elem, callback) {
			var hadExposure = false;
			if (utils.isInView($elem)) {
				// 统计曝光
				callback && callback();
				// 已曝光，不再注册下列滚动事件
				return
			}
			document.addEventListener('scroll', utils.throttle(function () {
				if (hadExposure) return;
				if (utils.isInView($elem)) {
					// 统计曝光
					callback && callback();
					hadExposure = true;
				}
			}, 300));
		},
		/**
		 * 弹窗控制类
		 */
		popupAlert: (function () {
			var $Dia = $(Dia);
			$Dia.find('.yid-cls-con').children().hide(); // 刚开始隐藏所有弹窗内容的显示
			var hadInsertBody = false; // 弹窗是否插入body中
			var curClassName = ''; // 当前弹窗

			function checkHide () {
				// 显示弹窗之前，检查其他弹窗是否关闭
				if (curClassName) {
					$Dia.hide();
				}
			}

			return {
				/**
				 * 获取弹窗对象
				 * @param className
				 * @returns {*}
				 */
				get$Dia: function (className) {
					return className ? $Dia.find('.' + className) : $Dia;
				},
				/**
				 * 隐藏弹窗
				 * @param callback
				 * @returns {*|jQuery.fn.init|jQuery|HTMLElement}
				 */
				hide: function (callback) {
					$Dia.find('.' + curClassName).hide();
					$Dia.hide();
					callback && callback();
					return $Dia;
				},
				/**
				 * 显示弹窗
				 * @param className 弹窗的class名称
				 * @param callback
				 * @returns {*|jQuery.fn.init|jQuery|HTMLElement}
				 */
				show: function (className, callback) {
					if (!className) return
					checkHide();
					curClassName = className;
					$Dia.find('.' + className).show();
					hadInsertBody ? $Dia.show() : ($('body').append($Dia) && (hadInsertBody = true));
					callback && callback();
					return $Dia;
				}
			}
		})()
	}
</script>

<style scoped lang="less">
	.flex-row {
		display: -moz-box;
		/* 老版本语法: Firefox (buggy) */
		display: -ms-flexbox;
		/* 混合版本语法: IE 10 */
		display: -webkit-flex;
		/* 新版本语法: Chrome 21+ */
		display: flex;
	}

	@cl-mask: rgba(0, 0, 0, 0.85);
	/**弹窗**/
	.yidialog-con {
		position: fixed;
		width: 100%;
		height: 100%;
		top: 0px;
		left: 0px;
		display: flex;
		align-items: center;
		justify-content: center;
		z-index: 1000;

		.yid-back {
			position: absolute;
			left: 0px;
			top: 0px;
			width: 100%;
			height: 100%;
			text-align: center;
			background: @cl-mask;
		}

		.yid-con {
			position: relative;
			display: flex;
			justify-content: center;
			align-content: center;
			color: #ffffff;
			flex-wrap: wrap;

			.yid-cls {
				position: relative;
				z-index: 9999;
				width: 0.51rem;
				height: 0.51rem;
				flex-shrink: 0;
			}

			.yid-hand {
				position: absolute;
				width: 1rem;
				top: 3.1rem;
				right: 0.1rem;
				animation: handClick 1s infinite;
			}
		}

		.yid-con-col {
			flex-direction: column;
		}
	}

	/**toast**/
	.yid-toast-con {
		display: none;

		.yid-back {
			opacity: 0;
		}

		.yid-con {
			.yid-con-body {
				justify-content: center;
				align-items: center;

				.msg {
					padding: 20px;
					background-color: #333333;
					color: #ffffff;
					font-size: 28px;
					border-radius: 10px;
				}
			}
		}
	}

	.my-hand-ani {
		animation: myHandAni 1s infinite;
	}

	@keyframes myHandAni {
		50% {
			left: 80px;
		}
		0%, 100% {
			left: 50px;
		}
	}

	@keyframes iconClick {
		0%, 100% {
			margin-bottotm: 0;
		}
		50% {
			margin-bottom: -35px;
			transform: scale(1.1);
		}
	}

	@keyframes handClick {
		from {
			margin-top: 0rem;
			margin-right: 0rem;
		}
		50% {
			margin-top: -0.1rem;
			margin-right: 0.1rem;
			transform: scale(0.9);
		}
		to {
			margin-top: -0rem;
			margin-right: 0rem;
		}
	}

	.scale-size {
		animation: scaleSize 2s infinite;
	}

	@keyframes scaleSize {
		from {
			transform: scale(0.9);
			opacity: 0.9;
		}
		50% {
			transform: scale(1.2);
			opacity: 1;
		}
		to {
			transform: scale(0.9);
			opacity: 0.9;
		}
	}

	.heart-beat {
		animation: heartBeat 1s infinite;
	}

	@keyframes heartBeat {
		0% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}

		14% {
			-webkit-transform: scale(.8);
			transform: scale(.8);
		}

		28% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}

		42% {
			-webkit-transform: scale(.8);
			transform: scale(.8);
		}

		70% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}
	}

	/**淡入*/
	.fade-in {
		animation: fadeIn 1s;
	}

	@keyframes fadeIn {
		from {
			opacity: 0;
		}
		to {
			opacity: 1;
		}
	}
</style>
